<template>
  <div
    class="select-executor-table"
  >
    <div
      v-if="value && !isEnabledSelect"
      class="cancel-resource-block"
    >
      <i class="icon alert" />
      <p>Для выбора или ввода вручную нового ресурса необходимо сначала <span class="link-style" @click="$emit('on-cancel-resource')">отменить назначение текущего ресурса</span>.</p>
    </div>
    <ObTable
      :remote-opt="remoteMethod"
      :columns="columns"
      :selected="{}"
      :functional-panel="false"
      :is-smart-pagination="false"
      :row-class-func="rowFunction"
      data-qa="selectResourceTableModal"
    >
      <div slot="gosNumber" slot-scope="{ data }">
        <div v-html="gosNumberHtml(data.item)" />
      </div>
      <div slot="status" slot-scope="{ data }">
        <div class="cell-status">
          <div :style="{ color: statusColors[data.item.status]}">{{ data.item.status }}</div>
          <template v-if="value && data.item.uuid === value.uuid">
            <button
              class="cancel-resource-button"
              @click="$emit('on-cancel-resource')"
            >
              <i class="icon close" />
            </button>
          </template>
          <template v-else-if="isEnabledSelect">
            <ObButton
              label="Назначить"
              :mini="true"
              data-qa="btnAppoint"
              @click="selectExecutor(data)"
            />
          </template>
        </div>
      </div>
    </ObTable>
  </div>
</template>

<script>
import ObTable from 'common-components/src/obComponents/obTable'
import ObButton from 'common-components/src/obComponents/obButton'
import moment from 'moment'

export default {
  name: 'OrderResourceSelectModal',
  components: {
    ObTable,
    ObButton
  },
  props: {
    value: {
      type: Object,
      default: null
    },
    remoteMethod: {
      type: Object,
      required: true
    },
    isEnabledSelect: {
      type: Boolean,
      default: true
    },
    resourceSuperclass: {
      type: String,
      required: true
    }
  },
  data () {
    return {
      statusColors: {
        'Доступен': '#10CF96',
        'Нет данных': '#9DA0AC'
      }
    }
  },
  computed: {
    columns() {
      if (['tractor', 'trailer', 'semitrailer', 'container_truck', 'van'].includes(this.resourceSuperclass)) {
        return [
          {
            title: `Группа риска`,
            key: 'icon',
            width: 80,
            html: (data) => `<i class="icon ${data.icon}" style="font-size: 22px;"></i>`
          },
          {
            title: 'Регистрационный номер',
            key: 'gos_number',
            slotName: 'gosNumber',
            width: 130,
          },
          {
            title: 'Подтип',
            key: 'resourceTypeTitle',
            width: 120,
            html: (data) => data.resourceTypeTitle ? data.resourceTypeTitle.split(' ')[0] : ''
          },
          {
            title: 'Тип ресурса',
            key: 'resourceTypeTitle',
            html: (data) => {
              let subType = data.resourceTypeTitle && data.resourceTypeTitle.split(' ')[0]
              return data.resourceTypeTitle ? data.resourceTypeTitle.replace(subType, '').trim() : '-'
            }
          },
          {
            title: 'Год выпуска',
            key: 'year',
            width: 90,
            html: (data) => data.year || '-'
          },
          {
            title: 'Выполнено рейсов',
            key: 'count',
            width: 110,
            html: (data) => data.count || '-'
          },
          {
            title: 'Право владения',
            key: 'pravo',
            width: 150,
            html: (data) => data.pravo || '-'
          },
          {
            title: 'Регистрация',
            key: 'reg',
            html: (data) => this.getHtmlDatetime(data.reg)
          },
          {
            title: 'статус',
            key: 'status',
            width: 150,
            slotName: 'status'
          }
        ]
      }

      if (['tractor'].includes(this.resourceSuperclass)) {
        return [
          {
            title: 'Регистрационный номер',
            key: 'gos_number',
            slotName: 'gosNumber',
            width: 140,
          },
          {
            title: `Группа риска`,
            key: 'icon',
            width: 80,
            html: (data) => `<i class="icon ${data.icon}" style="font-size: 22px;"></i>`
          },
          {
            title: 'Марка',
            key: 'mark'
          },
          {
            title: 'Год выпуска',
            key: 'year',
            width: 90,
            html: (data) => data.year || '-'
          },
          {
            title: 'Выполнено рейсов',
            key: 'count',
            width: 110,
            html: (data) => data.count || '-'
          },
          {
            title: 'Право владения',
            key: 'pravo',
            width: 150,
            html: (data) => data.pravo || '-'
          },
          {
            title: 'Регистрация',
            key: 'reg',
            html: (data) => this.getHtmlDatetime(data.reg)
          },
          {
            title: 'статус',
            key: 'status',
            width: 150,
            slotName: 'status'
          }
        ]
      }

      if (['driver'].includes(this.resourceSuperclass)) {
        return [
          {
            title: 'ФИО',
            key: 'fio'
          },
          {
            title: `Группа риска`,
            key: 'icon',
            width: 80,
            html: (data) => `<i class="icon ${data.icon}" style="font-size: 22px;"></i>`
          },
          {
            title: 'Номер телефона',
            key: 'phone',
            width: 130
          },
          {
            title: 'Выполнено рейсов',
            key: 'count',
            width: 110,
            html: (data) => data.count || '-'
          },
          {
            title: 'Регистрация',
            key: 'reg',
            html: (data) => this.getHtmlDatetime(data.reg)
          },
          {
            title: 'статус',
            key: 'status',
            width: 150,
            slotName: 'status'
          }
        ]
      }

      return []
    }
  },
  methods: {
    selectExecutor (data) {
      this.$emit('on-select', data.item)
    },
    rowFunction (data) {
      return data?.item.isDisabled ? '--disabled' : ''
    },
    gosNumberHtml (data) {
      if (data.grzReg) {
        return `<div class="gos-number">
                <span class="block">${data.grzNum}</span>
                <span class="block">${data.grzReg}</span>
              </div>`
      } else {
        return `<div class="gos-number">
                <span class="block">${data.grzNum}</span>
              </div>`
      }
    },
    getHtmlDatetime(datetime, isTime = true) {
      return datetime ? `
        <div class="field-datetime">
          <div>${moment(datetime).locale('ru').format('L')}</div>
          <div class="field-time ${isTime ? '' : 'hidden'}">${moment(datetime).locale('ru').format('LT')}</div>
        </div>
      ` : ''
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.max-width-100 {
  max-width: 100%;
}

.color-red {
  color: $light-raspberry-red;
}

.color-green {
  color: $color-green-light;
}

.color-gray {
  color: $color-grey-span;
}

.text-small {
  font-size: 12px;
  line-height: 20px;
}

.text-right {
  text-align: right;
}
</style>

<style lang="scss">
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';

  .select-executor-table {
    &:before {
      display: none !important;
    }
    table {
      min-width: auto!important;
    }
    .table-panel-inner {
      border-left: 1px solid $lavender;
      border-right: 1px solid $lavender;
      border-radius: 3px;
    }
    .table-footer {
      display: none;
    }
    .tariff-cell {
      @include font-mixin(14px, 18px, 600, $color-text-base, 0.2px);
    }

    .ob-table-inner.tb_showMore:before {
      display: none;
    }

    td {
      .td-container {
        min-height: 75px!important;
      }
    }

    td:last-child {
      opacity: 0;
      transition: opacity 0.2s;
      .td-container {
        justify-content: flex-end;
      }
    }

    tr {
      &:hover {
        td:last-child {
          opacity: 1;
        }
      }
      &.--disabled {
        background-color: $gray-200!important;
        cursor: not-allowed;
        td:last-child {
          opacity: 0!important;
        }
        .td-container {
          color: $color-grey-span;
        }
      }
    }

    .cancel-resource-block {
      display: flex;
      margin-bottom: 20px;
      padding: 20px;
      background-color: $color-white-lilac;
      i {
        margin-right: 20px;
        font-size: 24px;
        color: $color-blue-navy-blue;
      }
      p {
        @include font-mixin(14px, 20px, 400, $color-text-base, 0.2px);
      }
    }
    .cancel-resource-button {
      display: flex;
      align-items: center;
      border: none;
      background-color: transparent;
      outline: none;
      i {
        color: $color-grey-span;
        font-size: 14px;
      }
    }
  }
</style>
